
//load scripts
app.LoadScript( "theme.js" );

fille = "";
textsize = 18;
bgcolor = "#eeeeee";
textcolor = "black";
newtext = "";
timer = 0;
size = 25;
themename = "Light";
abs = null;
//start the app
function OnStart()
{
  //load the lay and controls
	CreateLayout();
}

function CreateLayout()
{
	//used to destroy the whole layout
	if(abs){
	  app.DestroyLayout( abs );
	}
	
	//start creating a new layout
	
	//insert a light theme
	them = app.CreateTheme( themename );
	them.SetTextColor(textcolor);
	them.SetBtnTextColor(textcolor);
	them.SetTitleColor(textcolor);
	app.SetTheme( them );
	
	//create an absolute layout
	abs = app.CreateLayout( "Absolute","FillXY" );
	
	//create theme button
	opt = app.CreateButton( "[fa-navicon]",-1,-1,"FontAwesome");
	opt.SetPosition( 0,.025);
	opt.SetTextSize( textsize );
	opt.SetOnTouch( opting);
	abs.AddChild( opt );
	
	//create title input
	title = app.CreateTextEdit( "", .64, -1,"SingleLine,Center" );
	title.SetPosition( .181, .022);
	//title.SetTextColor( textcolor );
	title.SetBackColor( bgcolor );
	title.SetTextSize( size );
	title.Focus();
	title.SetHint( "title.txt" );
	abs.AddChild( title );
	
	//create save button
	save = app.CreateButton( "[fa-save]",-1,-1,"FontAwesome" );
	save.SetPosition( .82,.025);
	save.SetTextSize( textsize );
	save.SetOnTouch( saving );
	abs.AddChild( save );
	
	//create a text input
	text = app.CreateTextEdit( "", .96, .78 );
	text.SetPosition( .02, .12);
	//text.SetTextColor( textcolor );
	text.SetBackColor( bgcolor ); 
	text.SetHint( "type something...." );
	abs.AddChild( text );
	
	//create a undo button
	undo = app.CreateButton( "[fa-rotate-left]",-1,-1,"FontAwesome");
	undo.SetPosition( 0,.92);
	undo.SetTextSize( textsize );
	undo.SetOnTouch( undoing);
	abs.AddChild( undo );
	
	//create a clear  button
	clear = app.CreateButton( "[fa-eraser]",-1,-1,"FontAwesome" );
	clear .SetPosition( .2,.92);
	clear.SetTextSize( textsize );
	clear.SetOnTouch( clearing );
	abs.AddChild( clear );
	
	//create an audio button
	audio = app.CreateButton( "[fa-microphone]",-1,-1,"FontAwesome" );
	audio.SetPosition( .4,.92);
	audio.SetTextSize( textsize );
	audio.SetOnTouch( audioing );
	audio.SetOnLongTouch( reading );
	abs.AddChild( audio );
	
	//create an choose  button
	choose = app.CreateButton( "[fa-file-text-o]",-1,-1,"FontAwesome" );
	choose.SetPosition( .6,.92);
	choose.SetTextSize( textsize );
	choose.SetOnTouch( choosing );
	abs.AddChild( choose );
	
	//create a redo button
	redo = app.CreateButton( "[fa-rotate-right]",-1,-1,"FontAwesome" );
	redo.SetPosition( .8,.92);
	redo.SetTextSize( textsize );
	redo.SetOnTouch( redoing );
	abs.AddChild( redo );
	
	//add abs to app
	app.AddLayout( abs );
	
	//create a yesno Dialog to confirm change
	yndlg = app.CreateYesNoDialog( "Do you really want to change your file's documentation?");
	yndlg.SetOnTouch( choice );
	
	//check if the File Exists
	exists = app.GetInternalFolder() + "/File";
	if(!(app.FolderExists(exists))) {
    folder = app.MakeFolder( exists );
    app.Alert( "All your saved files will be in your Internal Folder File's Directory" );
  }
  
 //create a  dialog
 dlg = app.CreateDialog( "OPTIONS" );
 dlg.SetOnBack(close);
 
 laydlg = app.CreateLayout( "Absolute");
 laydlg.SetSize( 0.9, 0.8);
 dlg.AddLayout( laydlg );
 
 ctheme = app.CreateText( "CHOOSE A THEME" );
 ctheme.SetPosition( .02, 0 );
 ctheme.SetTextSize( 20 );
 ctheme.SetTextColor( textcolor );
 laydlg.AddChild( ctheme );
 
 light = app.CreateButton( "Light Theme" );
 light.SetPosition( 0,.05);
 light.SetOnTouch( lighting );
 laydlg.AddChild( light );
 
 dark = app.CreateButton( "Dark Theme" );
 dark.SetPosition( .3,.05);
 dark.SetOnTouch( darking );
 laydlg.AddChild( dark );
 
 hack = app.CreateButton( "Hacker's Fav" );
 hack.SetPosition( .595,.05);
 hack.SetOnTouch( hacking );
 laydlg.AddChild( hack );
 
 help = app.CreateText( "HELP" );
 help.SetPosition( .02, .15);
 help.SetTextSize( 20 );
 help.SetTextColor( textcolor );
 laydlg.AddChild( help );

 lst = "SAVE:Used to save new titled files in the File Directory but can also be used to saved edit files:[fa-save],"+
 "UNDO:Used to undo what was written in the text input:[fa-rotate-left],"+
 "CLEAR:Used to clear the text in the text input:[fa-eraser],"+
 "SPEAK (SHORT PRESS):Used to record your voice then inputs your words in the text input:[fa-microphone],"+
 "SPEAK (LONG PRESS): Used to play what is in the text input:[fa-microphone],"+
 "REDO:Used to redo what was written in the text input:[fa-rotate-right]";
 list = app.CreateList( lst, .87, -1, "FontAwesome");
 list.SetPosition( .01, .19);
 laydlg.AddChild( list );
 
 about = app.CreateButton( "ABOUT DEVELOPER" );
 about.SetPosition( .24, .7);
 about.SetOnTouch( abouting );
 about.SetTextColor( textcolor );
 laydlg.AddChild( about );
 
 
 //about dialog
 abdlg = app.CreateDialog( "ABOUT ME" );
 abdlg.SetOnBack( close );
 ablay = app.CreateLayout( "Absolute", "FillXY" );
 ablay.SetSize( 0.8, 0.6 );
 abdlg.AddLayout( ablay );
 
 author = app.CreateText( "ABRAHAM" );
 author.SetTextSize( size );
 author.SetPosition( .225, 0);
 ablay.AddChild( author );

 aboutme = "Hello, my name is <b>Abraham</b>, I am an Android developer "+
 "who is currently studying Software Engineering. "+
 "Why did I make this app? "+
 "As students, we tend to have many assignments to work on "+
 "in the shortest possible time. " +
 "But with the help of this app, one can turn their words into text so nomore typing. "+
 "More free time to do other things.";
 me = app.CreateText( aboutme, .75,-1,"Top,Left,Multiline,Html,FillX" );
 me.SetPosition( .025, .05);
 me.SetTextSize( textsize );
 ablay.AddChild( me );
 
 fb = app.CreateText( "[fa-facebook-square]", 0.2, 0.2, "FontAwesome" );
 fb.SetTextSize( 60 );
 fb.SetPosition( .02, .43 );
 fb.SetTextColor( "#3B5999" );
 fb.SetOnTouch( fbing );
 ablay.AddChild( fb);
 
 gmail= app.CreateText( "[fa-google-plus-square]", 0.2, 0.2, "FontAwesome" );
 gmail.SetTextSize( 60 );
 gmail.SetTextColor( "#C54F3F" );
 gmail.SetPosition( .3, .43 );
 gmail.SetOnTouch( gmailing );
 ablay.AddChild( gmail );

 yt = app.CreateText( "[fa-youtube-square]", 0.2, 0.2, "FontAwesome" );
 yt.SetTextSize( 60 );
 yt.SetTextColor( "#A80000" );
 yt.SetPosition( .57, .43 );
 yt.SetOnTouch( yting );
 ablay.AddChild( yt );

//sms dialog
maildlg = app.CreateDialog( "EMAIL" ,"NoCancel");
maildlg.SetOnBack( close );

maillayDlg = app.CreateLayout( "Absolute", "FillXY" );
maillayDlg.SetSize( 0.9, 0.4 );
maillayDlg.SetPadding( .01,.01,.01,.01 );
maildlg.AddLayout( maillayDlg );
  
sendingto = "abrahamlupiya@protonmail.com";
  
subject = app.CreateTextEdit( "", .8, -1,"SingleLine" );
subject.SetPosition(.05, 0 );
subject.SetBackColor( bgcolor );
subject.SetHint( "Subject..." );
maillayDlg.AddChild( subject );
  
message = app.CreateTextEdit( "", .8, .2);
message.SetPosition(.05, .08 );
message.SetBackColor( bgcolor );
message.SetHint( "Type your message..." );
maillayDlg.AddChild( message );

mailcancel = app.CreateButton( "[fa-close]", -1,-1,"Center,FontAwesome" );
mailcancel.SetOnTouch( close );
mailcancel.SetPosition( .05, .3);
mailcancel.SetTextSize( 30 );
maillayDlg.AddChild( mailcancel );
  
mailme = app.CreateButton( "[fa-send]", -1,-1,"Center,FontAwesome" );
mailme.SetOnTouch( mailmeing );
mailme.SetPosition( .67, .3 );
mailme.SetTextSize( 30 );
maillayDlg.AddChild( mailme );

 //listening
 speech = app.CreateSpeechRec("NoBeep");
 speech.SetOnReady( ready );
 speech.SetOnResult( result );
 speech.SetOnError( error );
}

function mailmeing()
{
	app.SendMail( sendingto, subject.GetText(), message.GetText() );
	subject.SetText( "" );
	message.SetText( "" );
}


function fbing()
{
	app.OpenUrl( "https://www.facebook.com/Abraham.lupiya.linc" );
}

function gmailing()
{
	close();
	maildlg.Show();
}

function yting()
{
	app.OpenUrl( "https://www.youtube.com/playlist?list=PLAQOEHnD1kmoempvXe7OjbkiQD4QVG82Q" );
}

function close()
{
	dlg.Dismiss();
	abdlg.Dismiss();
	maildlg.Dismiss();
}


function abouting()
{
  dlg.Dismiss();
	abdlg.Show();
}

function reading()
{
  app.ShowPopup( "Please wait...\nI will read for you" );
	app.TextToSpeech( text.GetText(), 1, -1 );
}

function ready()
{
	app.ShowPopup( "I am Listening..." );
}

function result(res)
{
	newtext = res[0].trim();
	text.SetText( text.GetText() +" " + newtext );
}

function error()
{
  if(timer <2){
	  audioing();
	  timer++;
	}
	else{
	  app.ShowPopup( "Please speak more clearly" );
	  timer = 0;
	}
}

function opting()
{
	dlg.Show();
}

function undoing()
{
	text.Undo();
}

function clearing()
{
	text.SetText( "" );
}

function audioing()
{
	speech.Recognize();
}

function redoing()
{
	text.Redo();
}

function choice(yes)
{
	if(yes == "Yes"){
	  app.WriteFile( fille, text.GetText(), "ASCII", "UTF-8"  );
	  app.ShowPopup( "Saved" );
	}
}

function saving()
{
  filename =app.GetInternalFolder() + "/File/" + title.GetText().trim();
  if(fille == ""){
    if (title.GetText().trim().includes(".")){
	    app.WriteFile(filename , text.GetText(),"ASCII", "UTF-8" );
	    app.ShowPopup( "Saved as " + title.GetText() );
	  }else{
	   app.ShowPopup( "Please make sure your title has an extension." );
	  }
	}
	else if(fille != ""){
	  var split = fille.split("/");
    var pop = split.pop();
    if (pop == title.GetText()){
      yndlg.Show();
    }
	  if (pop != title.GetText()){
	    fille = "";
	    app.WriteFile(filename , text.GetText(),"ASCII", "UTF-8" );
	    app.ShowPopup( "Saved as " + title.GetText() );
	  }
	}
}

function choosing()
{
	app.ChooseFile( "Choose a file", "*/*", filing );
}

function filing(file)
{
  // app.SaveText( "file", file );
  fille = file;
  app.ShowPopup( file );
  var split = file.split("/");
  var pop = split.pop();
  title.SetText( pop );
	text.SetText( app.ReadFile( file, "UTF-8" ));
	if (file == "null"){
	  app.ShowPopup( "Only Works with Internal Files" );
	  title.SetText( "" );
  	text.SetText( "" );
  	fille = "";
	}
	
}